// let localEnv = "local";
// let localEnv = "dev";
let localEnv = "prod";

let localStatus = "idle";

let defaultAppActivity = "3";
let defaultSwipeNumber = "250";
let defaultSleepTime = "2300";
let defaultWakeTime = "0700";

let swiperinoDomain = "https://swiperino.com";
let swiperinoApiDomain = "https://api.swiperino.com";
if(localEnv === "local"){
  swiperinoDomain = "http://localhost:8888";
  swiperinoApiDomain = "http://localhost:3060";
}else if(localEnv === "dev"){
  swiperinoDomain = "https://testswiperino.com";
  swiperinoApiDomain = "https://api.testswiperino.com";
}

let toggleApps = {
  tinder: false,
  bumble: false,
  badoo: false,
}
let appDefaultOnOff = {
  tinder: true,
  bumble: true,
  badoo: false,
}

let plansEnum = {
  0: "Banned",
  1: "EmailUnverified",
  2: "Starter Plan",
  3: "Premium Plan",
  4: "AI Chat Pro Plan",
  5: "Elite Plan",//"Enterprise Plan",
  6: "Admin",
}


document.addEventListener('DOMContentLoaded', function() {
  const versionNumberElement = document.getElementById('version-number');
  versionNumberElement.textContent = chrome.runtime.getManifest().version;
});


// document.getElementById('tinder-open').addEventListener('click', function() {
//   chrome.runtime.sendMessage({command: "tinder-open"}, function(response) {
//     console.log(response);
//   });
// });

// document.getElementById('bumble-open').addEventListener('click', function() {
//   chrome.runtime.sendMessage({command: "bumble-open"}, function(response) {
//     console.log(response);
//   });
// });

// document.getElementById('tinder-close').addEventListener('click', function() {
//   chrome.runtime.sendMessage({command: "tinder-close"}, function(response) {
//     console.log(response);
//   });
// });

// document.getElementById('bumble-close').addEventListener('click', function() {
//   chrome.runtime.sendMessage({command: "bumble-close"}, function(response) {
//     console.log(response);
//   });
// });

window.onload = function() {
  let apps = document.querySelectorAll('.app');

  apps.forEach(function(app) {
    let slider = app.querySelector('.slider');

    app.addEventListener('click', function() {

      let appName = "tinder";
      if(app.classList.contains('bumble')){
        appName = "bumble";
      }else if(app.classList.contains('badoo')){
        appName = "badoo";
      }

      let toggledTo = true;
      if (app.classList.contains('on')) {
        app.classList.remove('on');
        app.classList.add('off');
        slider.textContent = 'Off';
        toggledTo = false;
      } else if(app.classList.contains('coming-soon') === false){
        app.classList.remove('off');
        app.classList.add('on');
        slider.textContent = 'On';
      }else{
        toggledTo = false;
      }
      try{
        toggleApps[appName] = toggledTo;
        let obj = {}
        obj[appName] = toggledTo
        chrome.storage.local.set(obj, function() {
          console.log('Data saved successfully');
        });
      }catch(e){}
    });
  });
};


$('#api-login-form').submit(function(e){
  e.preventDefault();
  var apiKey = $('#api-login-form input[type=text]').val();
  authAPIKey(apiKey);
});


function authAPIKey(apiKey){
  let path = "/api/get-user-info";
  let url = swiperinoApiDomain+path;

  let data = {
    appName: "extension-login",
  }

  data["swiperino-apikey"] = apiKey;

  $('.api-key-errors').empty().hide();
  if((typeof ajax != 'undefined')){ajax.abort();}
  startLoading();

  return ajax = $.ajax({
    method: "POST",
    url: url,
    data: data,
    dataType: "JSON",
    timeout: 30000,
    success: function(data){
      console.log("data",data);
      finishLoading();
      if(data.err.code === 0){
        logUserIn(data.res,apiKey);
      }else{
        $('.swiperino-api-key-error').append(data.err.message).fadeIn(200);
      }
    },
    error: function(xhr, ajaxOptions, thrownError){
      finishLoading();
      try{
        let d = xhr.responseJSON;
        console.log("d",d);
        $('.swiperino-api-key-error').append(d.err.message).fadeIn(200);
      }catch(e){
        var err = "signIn:Ajax:Error xhr.status:("+xhr.status+") thrownError("+thrownError+")";
        console.log(err);
        $('.swiperino-api-key-error').append(zTran(dl,'errMailUs')).fadeIn(200);
      }
    }
  });

}

function startLoading(){
  $('.swiperino-api-key-loading').fadeIn(200);
}

function finishLoading(){
  $('.swiperino-api-key-loading').stop().hide();
}

function logUserIn(data,apiKey){
  $('.user-div.log-in').hide();
  $('.user-div.logged-in').show();

  try{
    // console.log("set key");
    chrome.storage.local.set({ apiKey: apiKey }, function() {
      // console.log('Data saved successfully');
    });
  }catch(e){}

  $('.user-div.logged-in input').val(apiKey);
  $('.user-div.logged-in .status span').text(plansEnum[data.usn]);
  $('.user-div.logged-in .total-tokens span').text(data.chatTokens);

  fetchStartAutoChatSettings(apiKey);
}


try{
  // console.log("fetch key");

  chrome.storage.local.get(['apiKey',"tinder","bumble","badoo"], function(result) {
    // console.log("got key");
    // console.log("result",result);
    let apiKey = result.apiKey;
    toggleApps.tinder = result.tinder !== undefined?result.tinder:appDefaultOnOff.tinder;
    toggleApps.bumble = result.bumble !== undefined?result.bumble:appDefaultOnOff.bumble;
    toggleApps.badoo = result.badoo !== undefined?result.badoo:appDefaultOnOff.badoo;
    let toggleAppsArr = [
      {name:"tinder",toggle:toggleApps.tinder},
      {name:"bumble",toggle:toggleApps.bumble},
      {name:"badoo",toggle:toggleApps.badoo}
    ]
    toggleToggles(toggleAppsArr)
    authAPIKey(apiKey);
  });
}catch(e){}

try{
  chrome.runtime.sendMessage({ command: "get-status", }, function(response) {
    const swiperinoStatus = response.swiperinoStatus;
    if(swiperinoStatus === "running"){
      toggleLocalStatus("running");
    }
  });
}catch(e){}


function toggleToggles(arr){
  for (let i = 0; i < arr.length; i++) {
    const {name,toggle} = arr[i];
    // console.log("name",name);
    // console.log("toggle",toggle);

    let el = $('.app.'+name);
    let slider = el.find('.slider');
    if(toggle){
      el.removeClass('off').addClass('on');
      slider.text("On")
    }else{
      el.removeClass('on').addClass('off');
      slider.text("Off")
    }
  }
}

$('#start-stop-toggle').on("click",function(){
  let toggleAppsArr = [];

  for(let name in toggleApps){
    if(toggleApps[name]){
      toggleAppsArr.push(name);
    }
  }

  if(localStatus === "idle"){
    toggleLocalStatus("running");
  }else{
    toggleLocalStatus("idle");
  }

  let body = {
    command: "toggle-start-top",
    apps:toggleAppsArr,
    appActivity: inputAppActivityElement.value,
    swipeNumber: swipeNumberEl.val(),
    sleepTime: sleepTimeEl.val(),
    wakeTime: wakeTimeEl.val(),
  }

  chrome.runtime.sendMessage(body, function(response) {
    console.log("Response from background script:", response);
  });
});


function toggleLocalStatus(status){
  if(status === "idle"){
    localStatus = "idle";
    $('.status-info span').text("Idle");
    $('#start-stop-toggle').text("Start");
    chrome.action.setBadgeText({ text: "" });
    $('.carousel').removeClass("two").addClass("one")
    stopSwiperinoListener();
    $('.task-list ul').empty();
    $('.task-list ul').append('<li>Idle</li>');
  }else{
    localStatus = "running";
    $('.status-info span').text("Running");
    $('#start-stop-toggle').text("Stop");
    chrome.action.setBadgeText({ text: "On" });
    $('.carousel').removeClass("one").addClass("two")
    startSwiperinoListener();
  }
}

let interval = 0;
const startSwiperinoListener = () => {
	interval = setInterval(() => {
    chrome.runtime.sendMessage({ command: "fetch-task-list" }, function(response) {
      let taskList = response.taskList;
      $('.task-list ul').empty();
      for (let i = 0; i < taskList.length; i++) {
        let {app,task,} = taskList[i];
        let duration = taskList[i].duration?taskList[i].duration:null;
        let startTime = taskList[i].startTime?taskList[i].startTime:null;
        let ends = taskList[i].ends?taskList[i].ends:null;
        let amount = taskList[i].amount?taskList[i].amount:null;


        let li = '';
        li += '<li>';
        li +=   '<div><span class="'+app+'">'+capitalizeFirstLetter(app)+'</span> - <span class="'+task+'">'+kebabToDisplay(task)+'</span></div>';
        if(duration){
          let durationStr = millisecondsToDisplay(duration);
          li += '<div>Duration: '+durationStr+'</div>';
        }
        if(amount){
          li += '<div>Amount: '+amount+'</div>';
        }
        if(startTime){
          let timenow = new Date().getTime();
          let startTimeDate = new Date(startTime);
          let startTimeDateTime = new Date(startTime).getTime();
          let options = { month: 'long', day: 'numeric', hour: 'numeric', minute: 'numeric' };
          let startTimeDateStr = startTimeDate.toLocaleString('en-US', options);
          li += '<div>Start Time: ' + startTimeDateStr+'</div>';
          if(startTimeDateTime > timenow){
            let timeRemaing = startTimeDateTime - timenow;
            let timeRemaingStr = millisecondsToDisplayFull(timeRemaing);
            li += '<div>Starts In: ' + timeRemaingStr+'</div>';
          }
        }
        if(ends){
          let timenow = new Date().getTime();
          let endTime = new Date(ends).getTime();
          let timeRemaing = endTime - timenow;
          let timeRemaingStr = millisecondsToDisplayFull(timeRemaing);
          li += '<div>Ends In: ' + timeRemaingStr+'</div>';
        }
        li += '</li>';

        $('.task-list ul').append(li);
      }
      // console.log("Response from background script:", response);
    });
	},100)
}
const stopSwiperinoListener = () => {
	if(interval !== 0){
		clearInterval(interval)
		interval = 0;
	}
}


let timeArray = [
  "00:00","00:15","00:30","00:45","01:00","01:15","01:30","01:45","02:00","02:15","02:30","02:45","03:00","03:15","03:30","03:45","04:00","04:15","04:30","04:45","05:00","05:15","05:30","05:45","06:00","06:15","06:30","06:45","07:00","07:15","07:30","07:45","08:00","08:15","08:30","08:45","09:00","09:15","09:30","09:45","10:00","10:15","10:30","10:45","11:00","11:15","11:30","11:45","12:00","12:15","12:30","12:45","13:00","13:15","13:30","13:45","14:00","14:15","14:30","14:45","15:00","15:15","15:30","15:45","16:00","16:15","16:30","16:45","17:00","17:15","17:30","17:45","18:00","18:15","18:30","18:45","19:00","19:15","19:30","19:45","20:00","20:15","20:30","20:45","21:00","21:15","21:30","21:45","22:00","22:15","22:30","22:45","23:00","23:15","23:30","23:45","24:00",
]

let sleepTimeEl = $('#sleep-time');
let wakeTimeEl = $('#wake-time');
const inputAppActivityElement = document.getElementById("app-activity-input");
const sliderAppActivityElement = document.getElementById("app-activity-slider");
let swipeNumberEl = $('.swipe-amount input');



const convertToAMPM = (time) => {
  const hour = parseInt(time.substring(0, 2));
  const minute = parseInt(time.substring(3, 5));

  let period = "AM";
  let convertedHour = hour;

  if (hour >= 12) {
    period = "PM";
    if (hour > 12) {
      convertedHour = hour - 12;
    }
  }

  return `${convertedHour}:${minute.toString().padStart(2, "0")} ${period}`;
}

const setTimes = () => {
  sleepTimeEl.empty();
  wakeTimeEl.empty();
  for (let i = 0; i < timeArray.length; i++) {
    const time = timeArray[i];
    const removeStr = time.split(":")[0]+time.split(":")[1];
    const timeInt = parseInt(removeStr);
    const displayAmPm = convertToAMPM(time);
  
    let s1 = removeStr === defaultSleepTime?true:false;
    let s2 = removeStr === defaultWakeTime?true:false;
    
    if(timeInt >= 2000 && timeInt <= 2400){
      // sleepTimeEl.append('<option value="'+removeStr+'"'+((s1)?" selected ":"")+'>'+time+" ("+displayAmPm+")</option>");
      sleepTimeEl.append('<option value="'+removeStr+'"'+((s1)?" selected ":"")+'>'+time+"</option>");

    }
    if(timeInt >= 500 && timeInt <= 1000){
      // wakeTimeEl.append('<option value="'+removeStr+'"'+((s2)?" selected ":"")+'>'+time+" ("+displayAmPm+")</option>");
      wakeTimeEl.append('<option value="'+removeStr+'"'+((s2)?" selected ":"")+'>'+time+"</option>");
    }
  }
}
try{
  chrome.storage.local.get(['sleepTime',"wakeTime","appActivity","swipeNumber"], function(result) {
    defaultSleepTime = result.sleepTime?result.sleepTime:defaultSleepTime;
    defaultWakeTime = result.wakeTime?result.wakeTime:defaultWakeTime;
    defaultAppActivity = result.appActivity?result.appActivity:defaultAppActivity;
    defaultSwipeNumber = result.swipeNumber?result.swipeNumber:defaultSwipeNumber;

    sliderAppActivityElement.value = defaultAppActivity; 
    inputAppActivityElement.value = defaultAppActivity; 
    swipeNumberEl.val(defaultSwipeNumber);

    setTimes();
  });
}catch(e){}
setTimes();

sleepTimeEl.on("change",function(){
  let value = $(this).val();
  try{ chrome.storage.local.set({ 'sleepTime': value }, function() {}); }catch(e){}
})
wakeTimeEl.on("change",function(){
  let value = $(this).val();
  try{ chrome.storage.local.set({ 'wakeTime': value }, function() {}); }catch(e){}
})
swipeNumberEl.on("change",function(){
  let value = $(this).val();
  try{ chrome.storage.local.set({ 'swipeNumber': value }, function() {}); }catch(e){}
})


const millisecondsToDisplay = (duration) => {
  let durationStr = '';
  let seconds = Math.floor(duration / 1000);
  if (seconds < 60) {
    durationStr = seconds + (seconds === 1?' second':' seconds');
  } else if (seconds < 3600) {
    let minutes = Math.floor(seconds / 60);
    durationStr = minutes + (minutes === 1?' minute':' minutes');
  } else {
    let hours = Math.floor(seconds / 3600);
    durationStr = hours + (hours === 1?' hour':' hours');
  }
  return durationStr;
}

const millisecondsToDisplayFull = (duration) => {
  let durationStr = '';
  let seconds = Math.floor(duration / 1000);

  if (seconds < 60) {
    durationStr = seconds + (seconds === 1 ? ' second' : ' seconds');
  } else if (seconds < 3600) {
    let minutes = Math.floor(seconds / 60);
    let remainingSeconds = seconds % 60;
    durationStr = minutes + (minutes === 1 ? ' minute' : ' minutes') + ', ' +remainingSeconds + (remainingSeconds === 1 ? ' second' : ' seconds');
  } else {
    let hours = Math.floor(seconds / 3600);
    let remainingMinutes = Math.floor((seconds % 3600) / 60);
    let remainingSeconds = (seconds % 3600) % 60;
    durationStr = hours + (hours === 1 ? ' hour' : ' hours') + ', ' + remainingMinutes + (remainingMinutes === 1 ? ' minute' : ' minutes') + ', ' +remainingSeconds + (remainingSeconds === 1 ? ' second' : ' seconds');
  }

  return durationStr;
};



// Event listener for input element
inputAppActivityElement.addEventListener("input", function() {
  const value = parseInt(inputAppActivityElement.value);
  sliderAppActivityElement.value = value; // Update slider value
  try{
    chrome.storage.local.set({ 'appActivity': value }, function() {});
  }catch(e){}
});

// Event listener for slider element
sliderAppActivityElement.addEventListener("input", function() {
  const value = parseInt(sliderAppActivityElement.value);
  inputAppActivityElement.value = value; // Update input value
  try{
    chrome.storage.local.set({ 'appActivity': value }, function() {});
  }catch(e){}
});

$('.task-list button').on("click",function(){
  $('.task-list').toggleClass("expand");
  if($('.task-list').hasClass("expand")){
    $('.task-list button').text("Collapse Task List");
  }else{
    $('.task-list button').text("Expand");
  }
});

const capitalizeFirstLetter = (string) => {
	return string.charAt(0).toUpperCase() + string.slice(1);
}

const kebabToDisplay = (str) => {
  let words = str.split('-');
  return words.map(word => word.charAt(0).toUpperCase() + word.slice(1)).join(' ');
}


$('.auto-start-chat-div .toggle').on("click",() => {
  if($('.auto-start-chat-div').hasClass("loading")){
    return false;
  }

  $('.auto-start-chat-div').toggleClass("on");
  let toggledOn = false;
  let toggledText = "Off";
  if($('.auto-start-chat-div').hasClass("on")){
    toggledOn = true;
    toggledText = "On";
  }

  $('.auto-start-chat-div .toggle .slider').text(toggledText);
  var apiKey = $('#swiperino-api-key').val();
  saveStartAutoChatSettings(apiKey,toggledOn)
});

const fetchStartAutoChatSettings = (apiKey) => {
  console.log("fetchStartAutoChatSettings");
  
  let data = {}
  data["swiperino-apikey"] = apiKey;

  let path = "/user-match-settings/fetch";
  let url = swiperinoApiDomain+path;

  $('.auto-start-chat-div').addClass("loading");
  if((typeof matchAjax != 'undefined')){matchAjax.abort();}
  return matchAjax = $.ajax({
    method: "POST",
    url: url,
    data: data,
    dataType: "JSON",
    success: function(data){
      console.log("data",data);
      let {autoSetDate,autoStartChat,goal} = data.res;
      if(autoStartChat === true){
        $('.auto-start-chat-div').addClass("on");
        $('.auto-start-chat-div .toggle .slider').text("On");
      }
      $('.auto-start-chat-div').removeClass("loading");
    },
    error: function(xhr, ajaxOptions, thrownError){
      $('.auto-start-chat-div').removeClass("loading");
    }
  });

}

const saveStartAutoChatSettings = (apiKey,toggledOn) => {

  let autoStartChat = toggledOn?true:false;
  let data = {
    autoStartChat,
  }
  data["swiperino-apikey"] = apiKey;

  console.log("data",data);

  let path = "/user-match-settings/update";
  let url = swiperinoApiDomain+path;

  $('.ai-chat-history-pagination-loading').addClass("active");
  if((typeof matchAjax != 'undefined')){matchAjax.abort();}
  return matchAjax = $.ajax({
    method: "POST",
    url: url,
    data: data,
    // dataType: "JSON",
    success: function(data){
      console.log("data",data);
      $('.auto-start-chat-div').removeClass("loading");

    },
    error: function(xhr, ajaxOptions, thrownError){
      $('.auto-start-chat-div').removeClass("loading");
      $('.auto-start-chat-div').toggleClass("on");
    }
  });

}